/***********************************************************************
*  XPRESS Pressverbandberechnung
*  19.01.2007 Rieg
*  11.07.2022 Rieg: Glaettungsfaktor eingebbar
***********************************************************************/
#include <stdio.h>  /* printf */
#include <math.h>   /* pow */

#ifdef FR_TI89
#include <kbd.h>
#include <graph.h>
#endif

#ifdef FR_PC
#include <conio.h>
#endif

double DA,DF,DI,LF,EA,EI,nueA,nueI,ReA,ReI,RzA,RzI,my,FA,T,SH,SP;
double Uk,Ug,Umin,Umax,UV,Uwk,Zwk,QI,QA,K,QIQ,QAQ,pFk,FFk,Fzul,F,FT;
double Uwg,Zwg,pFg,pAzul,pIzul,alfaA,tA,GF;

double pi=3.14159265,wur3= 1.73205081;

int i;

/***********************************************************************
*  main
***********************************************************************/
#ifdef FR_PC
void main(void)
#endif
#ifdef FR_TI89
void _main(void)
#endif
{
int   ikey;
short key;

#ifdef FR_TI89
FontSetSys(F_6x8);
#endif

/*----------------------------------------------------------------------
*  Startwerte
----------------------------------------------------------------------*/
DA= 95;
DF= 60;
DI= 40;
LF= 20;

EA= 80000;
EI= 210000;
nueA= 0.35;
nueI= 0.3;

ReA= 160;
ReI= 215;

RzA= 16;
RzI= 10;

my= 0.17;

FA= 10000;
T= 0;

Uk= 92;
Ug= 141;

GF= 0.4;

SH= 1.5;
SP= 1.2;

alfaA= 17e-6;

/*----------------------------------------------------------------------
*  Ueberschrift fuer PC
----------------------------------------------------------------------*/
#ifdef FR_PC
printf("XPRESS ist die PC-Version des gleichnamigen Rechenprogramms\n");
printf("fuer Texas Instruments TI-89/92/V200 Taschenrechner.\n");
printf("Es hat daher keine Windows-Funktionalitaet, sondern ist\n");
printf("auf das Wesentliche reduziert: Eingabe-Rechnen-Ausgabe.\n\n");
printf("Der Lehrstuhl Konstruktionslehre+CAD,Prof.Dr.-Ing.Frank Rieg,\n");
printf("der UniversitaetBayreuth stellt Studenten eine Taschenrechner-\n");
printf("Programm-Sammlung fuer Maschinenelemente bereit, die man \n");
printf("-weil superkompakt- sozusagen immer dabei haben kann.\n");
printf("www.cad.uni-bayreuth.de\n");
printf("www.uni-bayreuth.de/departments/konstruktionslehre\n");
#endif

/*----------------------------------------------------------------------
*  Lbl start
----------------------------------------------------------------------*/
start:;

#ifdef FR_TI89
clrscr ();
#endif

#ifdef FR_PC
printf("\n");
#endif

printf("Pressverba.DIN 7190,i Info\n");
printf("F1 a Geometrie\n");
printf("F2 b Kraefte\n");
printf("F3 c Werkstoffe\n");
printf("F4 d Passungen\n");
printf("F5 e Hilfswerte\n");
printf("F6 w momentan def. Werte\n");
printf("F7 g Compute\n");
printf("F8 q Exit\n");

#ifdef FR_TI89
key=ngetchx();
#endif

#ifdef FR_PC
ikey=getch();
#endif

/*----------------------------------------------------------------------
* i Info
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == 'i')
#endif

#ifdef FR_PC
if(ikey == 'i')
#endif

  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("XPRESS n. DIN 7190,Prof.Dr.-Ing.Frank Rieg,\
Lehrstuhl Konstruktionslehre+CAD,\
Universitaet Bayreuth,11.7.2022\n");
  printf("weiter mit bel.Taste..");
#ifdef FR_TI89
  ngetchx ();
#endif
#ifdef FR_PC
  getch();
#endif
  goto start;
  }

/*----------------------------------------------------------------------
*  F8 Exit
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F8 || key == 'q') goto quit;
#endif

#ifdef FR_PC
if(ikey == 'q')goto quit;
#endif

/*----------------------------------------------------------------------
*  F1 a Geometrie
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F1 || key == 'a')
#endif

#ifdef FR_PC
if(ikey == 'a')
#endif
  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("Geometriewerte:");
  printf("\nAussend. DA[mm]= ");
  scanf("%lf",&DA);
  printf("\nFugend.  DF[mm]= ");
  scanf("%lf",&DF);
  printf("\nInnend.  DI[mm]= ");
  scanf("%lf",&DI);
  printf("\nLaenge LF[mm]= ");
  scanf("%lf",&LF);

  goto start;
  }

/*----------------------------------------------------------------------
*  F2 b Kraefte
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F2 || key == 'b')
#endif

#ifdef FR_PC
if(ikey == 'b')
#endif
  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("Momente + Kraefte:");
  printf("\nDrehmoment T[Nm]= ");
  scanf("%lf",&T);
  printf("\nAxialkraft FA[N]= ");
  scanf("%lf",&FA);

  goto start;
  }

/*----------------------------------------------------------------------
*  F3 c Werkstoffe
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F3 || key == 'c')
#endif

#ifdef FR_PC
if(ikey == 'c')
#endif
  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("Werkstoff-Kennwerte:");
  printf("\nEA[N/mm2]= ");
  scanf("%lf",&EA);
  printf("\nEI[N/mm2]= ");
  scanf("%lf",&EI);
  printf("\nQuerkon.A= ");
  scanf("%lf",&nueA);
  printf("\nQuerkon.I= ");
  scanf("%lf",&nueI);
  printf("\nStreckg.A= ");
  scanf("%lf",&ReA);
  printf("\nStreckg.I= ");
  scanf("%lf",&ReI);

  goto start;
  }

/*----------------------------------------------------------------------
*  F4 d Passungen
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F4 || key == 'd')
#endif

#ifdef FR_PC
if(ikey == 'd')
#endif
  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("gegebene Passung:");
  printf("\nKleinstmass Uk[ym]= ");
  scanf("%lf",&Uk);
  printf("\nGroesstmass Ug[ym]= ");
  scanf("%lf",&Ug);
  goto start;
  }

/*----------------------------------------------------------------------
*  F5 e Hilfswerte
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F5 || key == 'e')
#endif

#ifdef FR_PC
if(ikey == 'e')
#endif
  {
#ifdef FR_TI89
  clrscr ();
#endif

  printf("Hilfswerte:");
  printf("\nRauheit A[ym]= ");
  scanf("%lf",&RzA);
  printf("\nRauheit I[ym]= ");
  scanf("%lf",&RzI);
  printf("\nReibwert y= ");
  scanf("%lf",&my);
  printf("\nGlaettungsf.= ");
  scanf("%lf",&GF);
  printf("\nSicherh.SH= ");
  scanf("%lf",&SH);
  printf("\nSicherh.SP= ");
  scanf("%lf",&SP);
  printf("\nalfaA[1/K]= ");
  scanf("%lf",&alfaA);

  goto start;
  }

/*----------------------------------------------------------------------
* F6 Anzeige der Eingabewerte
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F6 || key == 'w')
#endif

#ifdef FR_PC
if(ikey == 'w')
#endif

  {
#ifdef FR_TI89
  clrscr ();
#endif
  printf("momentan def. Werte 1:\n");
  printf("Aussend.DA= %g mm\n",DA);
  printf("Fugend. DF= %g mm\n",DF);
  printf("Innend. DI= %g mm\n",DI);
  printf("Laenge  LF= %g mm\n",LF);
  printf("Drehmom. T= %g Nm\n",T);
  printf("Axialk. FA= %g N\n",FA);
  printf("E-Mod.A EA= %g N/mm2\n",EA);
  printf("E-Mod.I EI= %g N/mm2\n",EI);
  printf("Waermed.aA= %g 1/K\n",alfaA);
  printf("weiter mit bel.Taste..");

#ifdef FR_TI89
  key= ngetchx();
  if(key == 'x')  goto start;
  clrscr ();
#endif
#ifdef FR_PC
  ikey= getch();
  if(ikey == 'x') goto start;
  printf("\n");
#endif

  printf("momentan def. Werte 2:\n");
  printf("Querkon. A= %g\n",nueA);
  printf("Querkon. I= %g\n",nueI);
  printf("Streckg. A= %g N/mm2\n",ReA);
  printf("Streckg. I= %g N/mm2\n",ReI);
  printf("Rauheit  A= %g ym\n",RzA);
  printf("Rauheit  I= %g ym\n",RzI);
  printf("Reibwert y= %g\n",my);
  printf("Sicherh.SH= %g\n",SH);
  printf("Sicherh.SP= %g\n",SP);
  printf("weiter mit bel.Taste..");

#ifdef FR_TI89
  key= ngetchx();
  if(key == 'x')  goto start;
  clrscr ();
#endif
#ifdef FR_PC
  ikey= getch();
  if(ikey == 'x') goto start;
  printf("\n");
#endif

  printf("momentan def. Werte 3:\n");
  printf("Kleinstm. Uk= %g ym\n",Uk);
  printf("Groesstm. Ug= %g ym\n",Ug);
  printf("Glaettungsf.GF= %g\n",GF);
  printf("weiter mit bel.Taste..");

#ifdef FR_TI89
  key= ngetchx();
#endif
#ifdef FR_PC
  ikey= getch();
#endif

  goto start;
  }

/*----------------------------------------------------------------------
*  F7 g Berechnen
----------------------------------------------------------------------*/
#ifdef FR_TI89
if(key == KEY_F7 || key == 'g')
#endif

#ifdef FR_PC
if(ikey == 'g')
#endif

  {
#ifdef FR_TI89
  clrscr ();
#endif

/*======================================================================
*  QA,QI,UV,K,UV,Uwk,Zwk,pFk,FFk,Fzul
======================================================================*/
  QA=  DF/DA;
  QI=  DI/DF;
  QIQ= QI*QI;
  QAQ= QA*QA;
  K = EA/EI*((1+QIQ)/(1-QIQ)-nueI)+(1+QAQ)/(1-QAQ)+nueA;

  UV=  GF*(RzA+RzI)*0.001;
  Uwk= Uk*0.001-UV;
  Zwk= Uwk/DF;

  pFk=  Zwk*EA/K;
  FFk=  pFk*DF*pi*LF*my;
  Fzul= FFk/SH;

  tA=   (Ug*0.001 + 0.001*DF)/(alfaA*DF) + 20;

  printf("Ergebnisse 1:\n");
  printf("QA  = %g\n",QA);
  printf("QI  = %g\n",QI);
  printf("K   = %g\n",K);
  printf("UV  = %g mm\n",UV);
  printf("Uwk = %g mm\n",Uwk);
  printf("Zwk = %g\n",Zwk);
  printf("pFk = %g N/mm2\n",pFk);
  printf("FFk = %g N\n",FFk);
  printf("tA  = %g GradC\n",tA);
  printf("weiter mit bel.Taste..");

#ifdef FR_TI89
  key= ngetchx();
  if(key == 'x')  goto start;
  clrscr ();
#endif
#ifdef FR_PC
  ikey= getch();
  if(ikey == 'x') goto start;
  printf("\n");
#endif

/*======================================================================
*  F, Uwg, Zwg
======================================================================*/
  FT= T*2/DF*1000;  /* wg. Nm -> Nmm */
  F= sqrt(pow(FA,2) + pow(FT,2));

  Uwg= Ug*0.001-UV;
  Zwg= Uwg/DF;

  pFg=   Zwg*EA/K;
  pAzul= (1-QAQ)*ReA/(wur3*SP);
  pIzul= (1-QIQ)*ReI/(wur3*SP);

  printf("Ergebnisse 2:\n");
  printf("Fzul = %g N\n",Fzul);
  printf("F    = %g N\n",F);
  if(Fzul  >= F)   printf("Rutschsicherheit JA!\n");
  else             printf("Rutschsicherheit NEIN!\n");
  printf("pAzul= %g N/mm2\n",pAzul);
  printf("pFg  = %g N/mm2\n",pFg);
  if(pAzul >= pFg) printf("Fliesssicherh. A JA!\n");
  else             printf("Fliesssicherh. A NEIN!\n");
  printf("pIzul= %g N/mm2\n",pIzul);
  printf("pFg  = %g N/mm2\n",pFg);
  if(pIzul >= pFg) printf("Fliesssicherh. I JA!\n");
  else             printf("Fliesssicherh. I NEIN!\n");
  printf("weiter mit bel.Taste..");

#ifdef FR_TI89
  key= ngetchx();
#endif
#ifdef FR_PC
  ikey= getch();
#endif

  goto start;
  }

/*----------------------------------------------------------------------
*  Lbl quit
----------------------------------------------------------------------*/
goto start;  /* falsche Taste */
quit:;
}

